<?php

namespace Teknisa\MAN\Services;

use Zeedhi\Framework\DependencyInjection\InstanceManager;


class SMTP {

	const GET_SMTP = "
		SELECT DSSMTPAUTVND, DSEMAILAUVND, NRPORTAAUTVND, CDSENHAAUTVNDWEB,
			DSEMAILCLUSO, LOWER(DSSMTPCRIPT) AS DSSMTPCRIPT, IDTPAUTHSMTP
		FROM PARAMGERAL
	";

	protected $entityManager;

	public function __construct(\Doctrine\ORM\EntityManager $entityManager) {
		$this->entityManager = $entityManager;
	}

	public function getSMTP(){
		return $this->entityManager->getConnection()->fetchAll(self::GET_SMTP);
	}

	public function getSMTPFilial($CDFILIAL){
		$params = array(
			':CDFILIAL' => $CDFILIAL
		);

		return $this->entityManager->getConnection()->fetchAll(self::GET_SMTP_FILIAL, $params);
	}

	const GET_SMTP_FILIAL = "
		SELECT DSEMAILCLUSO
		FROM PARAVEND
		WHERE CDFILIAL = :CDFILIAL
	";     

	public function sendEmail($name_addressee, $email_addressee, $sender, $subject, $content) {
		// Get data from server
        $SMTP = $this->getSMTP();
        $username 	       = $SMTP[0]['DSEMAILAUVND'];
        $server   	       = $SMTP[0]['DSSMTPAUTVND'];
        $password 	       = $SMTP[0]['CDSENHAAUTVNDWEB'];
        $port     	       = $SMTP[0]['NRPORTAAUTVND'];
        $encryption        = $SMTP[0]['DSSMTPCRIPT'];
        $autentication     = $SMTP[0]['IDTPAUTHSMTP'];
        
        
        
		$this->configAndSend($username,$server,$password,$port,$encryption,$autentication,$name_addressee, $email_addressee, $sender, $message);  
    }
    
    public function sendEmailMessage($name_addressee, $email_addressee, $sender, $message) {
        $username 	       = 'retailmanagement@teknisa.com';
        $server   	       = 'smtp.teknisa.com';
        $password 	       = 'Retail@Man1234';
        $port     	       =  25;
        $encryption        = 'sem';
        $autentication     = 'S';
		
		$this->configAndSend($username,$server,$password,$port,$encryption,$autentication,$name_addressee, $email_addressee, $sender, $message);
    	
    }
    
    // The addredd is deprecated.
    private function configAndSend($username,$server,$password,$port,$encryption,$autentication,$name_addressee, $email_addressee, $sender, $message) {
    	$body = utf8_encode($this->generateEmail($sender, $message));
		// Using Lib function and configs.
		$smtpMail = InstanceManager::getInstance()->getService('smtpUtil');
        $smtpMail->setSubject($email_addressee);
        $smtpMail->setIsHTML(true);
        $smtpMail->sendMail($body, $email_addressee);
    }
    
    public function generateEmail($subject, $content) {
    	return
    		'<!DOCTYPE html>'.
            '<head>'.
			'<meta http-equiv="content-type" content="text/html; charset=UTF-8">'.
			'</head>'.
			'<body>'.
			'<div>'.
			'<font face="Arial" size="2"> '.$content.' </font>'.
			'</div>'.
			'<div>'.
			'<center><img src="https://manage.teknisa.com/assets/images/logo.png" style="width: 250px;"></center>'.
			'</div>'.
			'</body>'.
			'</html>'
		;
	}

}